package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.SpecService;
import com.gxwebsoft.shop.entity.Spec;
import com.gxwebsoft.shop.param.SpecParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 规格控制器
 *
 * @author 科技小王子
 * @since 2024-07-25 03:00:41
 */
@Api(tags = "规格管理")
@RestController
@RequestMapping("/api/shop/spec")
public class SpecController extends BaseController {
    @Resource
    private SpecService specService;

    @ApiOperation("分页查询规格")
    @GetMapping("/page")
    public ApiResult<PageResult<Spec>> page(SpecParam param) {
        // 使用关联查询
        return success(specService.pageRel(param));
    }

    @ApiOperation("查询全部规格")
    @GetMapping()
    public ApiResult<List<Spec>> list(SpecParam param) {
        // 使用关联查询
        return success(specService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:spec:list')")
    @ApiOperation("根据id查询规格")
    @GetMapping("/{id}")
    public ApiResult<Spec> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(specService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:spec:save')")
    @ApiOperation("添加规格")
    @PostMapping()
    public ApiResult<?> save(@RequestBody Spec spec) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
         spec.setUserId(loginUser.getUserId());
        }
        if (specService.save(spec)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:spec:update')")
    @ApiOperation("修改规格")
    @PutMapping()
    public ApiResult<?> update(@RequestBody Spec spec) {
        if (specService.updateById(spec)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:spec:remove')")
    @ApiOperation("删除规格")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (specService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:spec:save')")
    @ApiOperation("批量添加规格")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<Spec> list) {
        if (specService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }


    @PreAuthorize("hasAuthority('shop:spec:update')")
    @ApiOperation("批量修改规格")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<Spec> batchParam) {
        if (batchParam.update(specService, "spec_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }
    @PreAuthorize("hasAuthority('shop:spec:remove')")
    @ApiOperation("批量删除规格")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (specService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
